<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:12 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>ContentFilterable (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ContentFilterable (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/file/ConfigurableFileTree.html" title="interface in org.gradle.api.file"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/file/ContentFilterable.html" target="_top">Frames</a></li>
<li><a href="ContentFilterable.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.file</div>
<h2 title="Interface ContentFilterable" class="title">Interface ContentFilterable</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Known Subinterfaces:</dt>
<dd><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a>, <a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>, <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a></dd>
</dl>
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><a href="../../../../org/gradle/api/tasks/bundling/AbstractArchiveTask.html" title="class in org.gradle.api.tasks.bundling">AbstractArchiveTask</a>, <a href="../../../../org/gradle/api/tasks/AbstractCopyTask.html" title="class in org.gradle.api.tasks">AbstractCopyTask</a>, <a href="../../../../org/gradle/api/tasks/Copy.html" title="class in org.gradle.api.tasks">Copy</a>, <a href="../../../../org/gradle/plugins/ear/Ear.html" title="class in org.gradle.plugins.ear">Ear</a>, <a href="../../../../org/gradle/jvm/tasks/Jar.html" title="class in org.gradle.jvm.tasks">Jar</a>, <a href="../../../../org/gradle/api/tasks/bundling/Jar.html" title="class in org.gradle.api.tasks.bundling">Jar</a>, <a href="../../../../org/gradle/language/jvm/tasks/ProcessResources.html" title="class in org.gradle.language.jvm.tasks">ProcessResources</a>, <a href="../../../../org/gradle/api/tasks/Sync.html" title="class in org.gradle.api.tasks">Sync</a>, <a href="../../../../org/gradle/api/tasks/bundling/Tar.html" title="class in org.gradle.api.tasks.bundling">Tar</a>, <a href="../../../../org/gradle/api/tasks/bundling/War.html" title="class in org.gradle.api.tasks.bundling">War</a>, <a href="../../../../org/gradle/api/tasks/bundling/Zip.html" title="class in org.gradle.api.tasks.bundling">Zip</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="strong">ContentFilterable</span></pre>
<div class="block">Represents some binary resource whose content can be filtered.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/ContentFilterable.html#expand(java.util.Map)">expand</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;properties)</code>
<div class="block">Expands property references in each file as it is copied.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/ContentFilterable.html#filter(java.lang.Class)">filter</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="https://docs.oracle.com/javase/7/docs/api/java/io/FilterReader.html?is-external=true" title="class or interface in java.io">FilterReader</a>&gt;&nbsp;filterType)</code>
<div class="block">Adds a content filter to be used during the copy.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/ContentFilterable.html#filter(groovy.lang.Closure)">filter</a></strong>(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</code>
<div class="block">Adds a content filter based on the provided closure.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/ContentFilterable.html#filter(java.util.Map,%20java.lang.Class)">filter</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;properties,
      <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="https://docs.oracle.com/javase/7/docs/api/java/io/FilterReader.html?is-external=true" title="class or interface in java.io">FilterReader</a>&gt;&nbsp;filterType)</code>
<div class="block">Adds a content filter to be used during the copy.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/ContentFilterable.html#filter(org.gradle.api.Transformer)">filter</a></strong>(<a href="../../../../org/gradle/api/Transformer.html" title="interface in org.gradle.api">Transformer</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;transformer)</code>
<div class="block">Adds a content filter based on the provided transformer.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="filter(java.util.Map, java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filter</h4>
<pre><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a>&nbsp;filter(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;properties,
                       <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="https://docs.oracle.com/javase/7/docs/api/java/io/FilterReader.html?is-external=true" title="class or interface in java.io">FilterReader</a>&gt;&nbsp;filterType)</pre>
<div class="block"><p>Adds a content filter to be used during the copy.  Multiple calls to filter, add additional filters to the
 filter chain.  Each filter should implement <code>java.io.FilterReader</code>. Include <code>org.apache.tools.ant.filters.*</code> for access to all the standard Ant filters.</p>

 <p>Filter properties may be specified using groovy map syntax.</p>

 <p> Examples:
 <pre>
    filter(HeadFilter, lines:25, skip:2)
    filter(ReplaceTokens, tokens:[copyright:'2009', version:'2.3.1'])
 </pre></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>properties</code> - map of filter properties</dd><dd><code>filterType</code> - Class of filter to add</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filter(java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filter</h4>
<pre><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a>&nbsp;filter(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="https://docs.oracle.com/javase/7/docs/api/java/io/FilterReader.html?is-external=true" title="class or interface in java.io">FilterReader</a>&gt;&nbsp;filterType)</pre>
<div class="block"><p>Adds a content filter to be used during the copy.  Multiple calls to filter, add additional filters to the
 filter chain.  Each filter should implement <code>java.io.FilterReader</code>. Include <code>org.apache.tools.ant.filters.*</code> for access to all the standard Ant filters.</p>

 <p> Examples:
 <pre>
    filter(StripJavaComments)
    filter(com.mycompany.project.CustomFilter)
 </pre></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>filterType</code> - Class of filter to add</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filter(groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filter</h4>
<pre><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a>&nbsp;filter(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</pre>
<div class="block">Adds a content filter based on the provided closure.  The Closure will be called with each line (stripped of line
 endings) and should return a String to replace the line or <code>null</code> to remove the line.  If every line is
 removed, the result will be an empty file, not an absent one.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>closure</code> - to implement line based filtering</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filter(org.gradle.api.Transformer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filter</h4>
<pre><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a>&nbsp;filter(<a href="../../../../org/gradle/api/Transformer.html" title="interface in org.gradle.api">Transformer</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;transformer)</pre>
<div class="block">Adds a content filter based on the provided transformer.  The Closure will be called with each line (stripped of line
 endings) and should return a String to replace the line or <code>null</code> to remove the line.  If every line is
 removed, the result will be an empty file, not an absent one.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>transformer</code> - to implement line based filtering</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="expand(java.util.Map)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>expand</h4>
<pre><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a>&nbsp;expand(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;properties)</pre>
<div class="block"><p>Expands property references in each file as it is copied. More specifically, each file is transformed using
 Groovy's <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/text/SimpleTemplateEngine.html?is-external=true" title="class or interface in groovy.text"><code>SimpleTemplateEngine</code></a>. This means you can use simple property references, such as
 <code>$property</code> or <code>${property}</code> in the file. You can also include arbitrary Groovy code in the
 file, such as <code>${version ?: 'unknown'}</code> or <code>${classpath*.name.join(' ')}</code></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>properties</code> - to implement line based filtering</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/file/ConfigurableFileTree.html" title="interface in org.gradle.api.file"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/file/ContentFilterable.html" target="_top">Frames</a></li>
<li><a href="ContentFilterable.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
